<template>
	<div class="relative box-border mt-4 w-full md:w-460 lg:w-610">
		<div class="flex justify-center items-center">
      <MKSpinnerAnimation v-if="!creditCardLoaded" />
    </div>
		<div
			v-show="creditCardLoaded"
			id="customCard-container"
			class="cell mk-cc-input input-elements border-b md:border-grey-20 lg:border-grey-20"
			variant="outline"
		>
			<div class="fields cc-fields">
				<div id="s-cc-card-icon">
					<img class="w-10 h-6 icon-margin" :src="require('~/assets/images/' + CARD_ICON)" alt="" />
				</div>
				<div class="field cc-field-number w-2/4 md:w-2/4 pr-4">
					<div
						id="a-cc-card-number"
						ref="encryptedCardNumber"
						data-cse="encryptedCardNumber"
						class="input empty pl-2 w-full h-14"
					></div>
					<!-- eslint-disable-next-line vuejs-accessibility/label-has-for  -->
					<label for="a-cc-card-number" class="s-cc-labels number-left mb-1">Card number</label>
					</div>
				<div class="field cc-field-item w-16 md:w-1/6 pr-4">
					<div
						id="a-cc-card-expiry"
						ref="encryptedExpiryDate"
						data-cse="encryptedExpiryDate"
						class="input empty md:ml-0 w-full h-14"
					></div>
					<!-- eslint-disable-next-line vuejs-accessibility/label-has-for  -->
					<label for="a-cc-card-expiry" class="s-cc-labels month-left md:ml-0 mb-1">MM/YY</label>
				</div>
				<div class="field cc-field-item w-10 md:w-1/6">
					<div
						id="a-cc-card-cvc"
						ref="encryptedSecurityCode"
						data-cse="encryptedSecurityCode"
						class="input empty w-full h-14"
					></div>
					<!-- eslint-disable-next-line vuejs-accessibility/label-has-for  -->
					<label for="a-cc-card-cvc" class="s-cc-labels mb-1">CVV</label>
				</div>
			</div>
		</div>
		<ValidationProvider v-slot="{ errors }" rules="required">
			<div v-if="ADYEN_ERROR_MSG" class="error text-xs text-error-20 md:text-sm my-1" role="alert" v-show="creditCardLoaded">
				<span class="message">{{ ADYEN_ERROR_MSG || errors[0] }}</span>
			</div>
			<input
        type="hidden"
        vid="vid_credit_card"
        :value="ccFilled && !ADYEN_ERROR_MSG ? 1 : ''"
      />
		</ValidationProvider>
		<MkInput v-show="creditCardLoaded" class="mb-4 mt-4" :value="cardHolderName" variant="outline" label="Cardholder name" @input="cardHolderName = $event" />
	</div>
</template>

<script>
import { ValidationProvider } from 'vee-validate';
import { mapState } from 'vuex';
import MkInput from '~/components/D2C/atoms/MkInput.vue';
import MKSpinnerAnimation from '~/components/D2C/atoms/MKSpinnerAnimation.vue'

export default {
	components: {
		ValidationProvider,
		MkInput,
		MKSpinnerAnimation
	},
	data() {
		return {
			showCardPlaceHolder: false,
			cardHolderName: '',
			cardFilled: '',
			creditCardLoaded: false
		};
	},
	computed: {
		...mapState('ADYEN_STORE', ['CARD_ICON', 'VALID_CARD', 'ADYEN_ERROR_MSG']),
		 ccFilled() {
      return this.cardFilled
    }
	},
	mounted() {
		const AdyenCheckout = require('@adyen/adyen-web');
		const self = this;
		const translations = {
			'en-us': {
				'creditCard.expiryDateField.placeholder': '',
				'creditCard.cvcField.placeholder.3digits': '',
				'creditCard.numberField.placeholder': '',
			},
		};
		const configuration = {
			locale: 'en_us',
			environment: 'test',
			clientKey: 'test_G5NU5KIJOVCX3B22AIO2QTTVXY2JQSN6',
			translations,
		};

		const checkout = new AdyenCheckout(configuration);

		checkout
			.create('securedfields', {
				// Optional configuration
				type: 'card',
				brands: ['mc', 'visa', 'amex', 'bcmc', 'maestro', 'diners', 'jcb', 'discover', 'cup'],
				styles: {
					base: {
						fontSize: '16px',
						fontFamily: 'Akkurat Pro Regular',
						fontWeight: 300,
					},
					// placeholder: {
					// 	color: 'white',
					// },
					error: {
						color: '#ed5d71',
					},
				},
				async onChange(state, component) {
					self.$emit('card-filled', state.isValid);
					self.cardFilled = false;
					// await self.$store.dispatch('ADYEN_STORE/CARD_VALIDATION', state);
					if (!state.errors.encryptedCardNumber) {
						await self.$store.dispatch('ADYEN_STORE/CARD_ICON', { brand: self.VALID_CARD });
					}
				},
				async onBrand(state, component) {
					await self.$store.dispatch('ADYEN_STORE/CARD_ICON', state);
				},
				async onError(state, component) {
					if (state.error) {
						await self.$store.dispatch('ADYEN_STORE/CARD_VALIDATION', state);
					} else if (!state.error && state.errorText === 'error was cleared') {
						await self.$store.dispatch('ADYEN_STORE/CARD_VALIDATION', state);
					}
					if (state.error && state.fieldType === 'encryptedCardNumber') {
						await self.$store.dispatch('ADYEN_STORE/CARD_ICON', state);
					}
				},
				onFocus(state, component) {
					const fieldRef = state.fieldType;
					if (state.focus && fieldRef) {
						self.$refs[fieldRef].classList.add('focused');
					} else if (!state.focus && fieldRef && !state.numChars) {
						self.$refs[fieldRef].classList.remove('focused');
					}
				},
				onBinValue(bin) {},
				async onValid(state, component) {
					await self.$store.dispatch('ADYEN_STORE/CARD_VALIDATION', state);
					self.cardFilled = true;
					await self.$store.dispatch('ADYEN_STORE/ADYEN_CARD_DETAILS', state.data.paymentMethod);
					self.$emit('card-filled', true);
				},
				onLoad() {},
				async onConfigSuccess(state) {
					//Reset the validation error
					await self.$store.dispatch('ADYEN_STORE/CARD_VALIDATION', state);
					self.creditCardLoaded = true
				},
				onFieldValid(state, component) {
					if(!state.valid) {
							self.$store.dispatch('ADYEN_STORE/ADYEN_CARD_DETAILS', {});
					}
				},
			})
			.mount('#customCard-container');
	},
};
</script>

<style scoped>
.mk-cc-input .field {
	position: relative;
	height: 50px;

	/* margin: 0 10px; */
}
.icon-margin {
	margin: 0 16px 0 0;
}
.mk-cc-input label {
	position: absolute;
	bottom: 10px;
	left: 0;
	width: 100%;
	overflow: hidden;
	color: #000;
	text-overflow: ellipsis;
	white-space: nowrap;
	pointer-events: none;
	cursor: text;
	transition-timing-function: cubic-bezier(0.165, 0.84, 0.44, 1);
	transition-duration: 0.3s;
	transition-property: color, transform;
	transform-origin: 0 50%;
}

.mk-cc-input .month-left {
	transform: translateX(0);
}
.mk-cc-input .number-left {
	transform: translateX(5px);
}

.mk-cc-input .input {
	position: absolute;
	left: 0;
	width: 100%;
	padding-bottom: 0;
	padding-left: 0;
	color: #32325d;
	background-color: transparent;
}

/* .mk-cc-input .input .js-iframe-input.input-field {
position: absolute;
  width: 100%;
  left: 0;
  padding-bottom: 0px;
  color: #32325d;
  background-color: transparent;
  padding-left: 0;
} */

.mk-cc-input .input::-webkit-input-placeholder {
	color: transparent;
	transition: color 0.3s cubic-bezier(0.165, 0.84, 0.44, 1);
}
.mk-cc-input .input-field ::-webkit-input-placeholder {
	color: transparent;
	transition: color 0.3s cubic-bezier(0.165, 0.84, 0.44, 1);
}

.mk-cc-input .input::-moz-placeholder {
	color: transparent;
	transition: color 0.3s cubic-bezier(0.165, 0.84, 0.44, 1);
}

.mk-cc-input .input:-ms-input-placeholder {
	color: transparent;
	transition: color 0.3s cubic-bezier(0.165, 0.84, 0.44, 1);
}

.mk-cc-input .input.StripeElement {
	opacity: 0;
	transition: opacity 0.3s cubic-bezier(0.165, 0.84, 0.44, 1);
	will-change: opacity;
}

.mk-cc-input .input.focused,
.mk-cc-input .input:not(.empty) {
	opacity: 1;
}

.mk-cc-input .input.focused::-webkit-input-placeholder,
.mk-cc-input .input:not(.empty)::-webkit-input-placeholder {
	color: #cfd7df;
}

.mk-cc-input .input.focused::-moz-placeholder,
.mk-cc-input .input:not(.empty)::-moz-placeholder {
	color: #cfd7df;
}

.mk-cc-input .input.focused:-ms-input-placeholder,
.mk-cc-input .input:not(.empty):-ms-input-placeholder {
	color: #cfd7df;
}

.mk-cc-input .input.focused + label,
.mk-cc-input .input:not(.empty) + label {
	font-size: 14px;
	line-height: 16px;
	color: #000;
	cursor: default;
	transform: scale(0.85) translateY(-25px);
}
.mk-cc-input .input.focused + label[for='a-cc-card-number'],
.mk-cc-input .input:not(.empty) + label[for='a-cc-card-number'] {
	transform: scale(0.85) translateX(0) translateY(-25px);
}
.mk-cc-input .input.focused + label[for='a-cc-card-expiry'],
.mk-cc-input .input:not(.empty) + label[for='a-cc-card-expiry'] {
	transform: scale(0.85) translateX(0) translateY(-25px);
}

.mk-cc-input .input.focused + label {
	font-size: 14px;
	line-height: 16px;
	color: #000;
}
.mk-cc-input .InputContainer .InputElement {
	top: 4px;
}
.input .js-iframe-input.input-field::-webkit-input-placeholder,
.input .js-iframe-input.input-field::placeholder,
.input .js-iframe-input.input-field::-moz-placeholder,
.input .js-iframe-input.input-field::-ms-input-placeholder {
	color: transparent;
}
.input-field:placeholder-shown {
	font-weight: 200;
	color: transparent;
}
</style>
<style lang="scss">
.cc-input {
	@media (max-width: 900px) {
		width: 70%;
	}

	@media (max-width: 600px) {
		width: 100%;
	}
}
</style>
<style lang="postcss">
.cc-input {
	@apply mt-4 h-16;
}
.s-cc-labels {
	@apply absolute duration-300 origin-0 font-primary-font-light text-sm;
}
.mk-cc-input label {
	@apply text-base font-primary-font-light;
}
.mk-cc-input {
	@apply h-15;
}
.CardBrandIcon img {
	@apply w-9 h-6;
}
.mk-cc-input .input.focused + label,
.mk-cc-input .input:not(.empty) + label {
	@apply font-primary-font-bold;
}
.ElementsApp,
.ElementsApp .InputContainer .InputElement {
	@apply font-primary-font-bold !important;
}
</style>

<style lang="scss">
.input-field:placeholder-shown {
	font-weight: 200;
	color: red;
}
.cc-fields {
	display: flex;
	flex-direction: row;
	flex-wrap: nowrap;
	align-items: center;
}
.cc-field-item {
	flex: auto;
	margin: 10px;
	margin-right: 0;
	margin-left: 0;
}
</style>
